// Created by Christopher Tremblay <ti_chris@yahoo.com>
// Version 1.0
// This program will compress using a variation of LITE86
// The later has been reversed engineered to notice the optimization features
// it has.  Greating to Kirk who is the creator of Lite86.
// Compiled with BC 3.0 (Yeah it's old but it does the job for DOS programs)

#define gcc

#include <stdio.h>                              // File/Screen IO
 #ifndef gcc
#include <conio.h>                              // Used for the fancy colors
#include <mem.h>                                // Used for the memory ops
 #endif
#include <ctype.h>                              // Used for toupper
#include <stdlib.h>

typedef unsigned char BYTE;
typedef unsigned int  WORD;
typedef unsigned long DWORD;

#define Exception (1 << (8 + MaxABit - 2))      // 00xxxxxx
#define MaxDBit 6                               // (  1.. 64) = 00xxxxxxb
#define MaxCBit 5                               // (  2.. 33) = ???xxxxxb
#define MaxABit 3                               // (  1..  7) = xxX?????b
// Constants calculate with the bit choices
#define MaxDLen (1 << MaxDBit) - 1              // where xx != 00xb
#define MaxCLen (1 << MaxCBit) + 1
#define MaxALen (1 << (8 + MaxABit)) - Exception
#define MaxReCLen MaxCLen + 256

char Dec2Hex[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#define CompLen 68
BYTE SelfUnComp[CompLen] = {                    // Program which self-extracts
 62,  65, 211,   6,  33,  97, 215,  17,   0, 130,   1,  44,   0, 237, 176,
 17,  72, 215, 213,  33,  43, 130, 195,   0, 130, 126,  35, 254,  63,  48,
  7, 183, 200,  79, 237, 176,  24, 243, 245, 230,  31, 198,   2, 254,  33,
 32,   4, 134, 203,  16,  35,  79, 241, 229, 110,   7,   7,   7, 246, 248,
103,  25, 237, 176, 225,  35,  24, 213};

BYTE BufI[16384], BufO[16384];
int  AtI = 1, AtO = 0, AtD = 0, LenD = 1;
int  OccAddr;
long Occ;
FILE *In, *Out;
WORD OccLen, Len, Temp, FLen, ChkSum;
BYTE ArgAt;
char Name[9] = {0, 0, 0, 0, 0, 0, 0, 0, 0};

// The data written here is NOR RLE friendly NOR LZ friendly
void SaveDump(void)
{
   BufO[AtO++] = LenD;
   memcpy(BufO + AtO, BufI + AtD, LenD);
   AtO += LenD;
   AtD = -1;
   LenD = 0;
}

void main(int ArgCount, char *Args[])
{
   // First check the arguments
   if ((ArgCount < 3) || ((Args[1][0] == '/') && (Args[1][1] == '?')))
   {
      printf("Usage : %s [/B] [/P] [/S] [/T] [/X] [/?] <Source> <Destination> [Start]\n\n", Args[0]);
      printf("  /B\t\tSave as a binary (default)\n");
      printf("  /P\t\tSave as a self-extracting 86P program file\n");
      printf("  /S\t\tSave as a binary 86S string file\n");
      printf("  /T\t\tSave as a textual '.DB' styled assembly text file\n");
      printf("  /X\t\tSave as a self-extracting binary file\n");
      printf("  /?\t\tHelp text (this)\n");
      printf("  Source\tSpecifies the file to be compressed\n");
      printf("  Destination\tSpecifies the file to contain the compressed data\n");
      printf("  Start\t\tSpecifies the amounth of bytes to leave as is  at the beginning\n\n");
      printf("Ex : %s /P Prog.bin Prog.86P 47\n\n", Args[0]);
      return;
   }

   if (Args[1][0] == '/')
      ArgAt = 1;
   else
      ArgAt = 0;

   if ((In = fopen(Args[ArgAt + 1], "rb")) == NULL)
   {
      printf("File not found : %s\n", Args[1]);
      return;
   }

   if ((Args[1][0] == '/') && (toupper(Args[1][1]) == 'T'))
   {
      if ((Out = fopen(Args[ArgAt + 2], "wt")) == NULL)
      {
         printf("File can't be created : %s\n", Args[2]);
         return;
      }
   }
   else if ((Out = fopen(Args[ArgAt + 2], "wb")) == NULL)
   {
      printf("File can't be created : %s\n", Args[2]);
      return;
   }

 #ifndef gcc
   _asm{
      mov  ax, 3
      int  10h
   }
 #endif

 #ifdef gcc
   printf("Lite86^2 Created by Christopher Tremblay <ti_chris@yahoo.com>\n\n\r");
 #else
   textattr(0x0B);
   directvideo = 1;
   cprintf("Lite86 Created by Christopher Tremblay <ti_chris@yahoo.com>\n\n\r");
   textattr(0x03);
 #endif

   fseek(In, 0, SEEK_END);
   FLen = ftell(In);
   if (FLen > 16384)
   {
      printf("File is too big to be compressed\n");
      return;
   }
   fseek(In, 0, SEEK_SET);
   fread(BufI, 1, FLen, In);
   fclose(In);
   if (ArgCount > ArgAt + 3)
   {
      memcpy(BufO, BufI, atoi(Args[ArgAt + 3]));
      AtO = atoi(Args[ArgAt + 3]);
      AtI = AtO;
      AtD = -1;
      LenD = 0;
      OccLen = 0x822B;
      SelfUnComp[20] = OccLen & 255;
      SelfUnComp[21] = OccLen >> 8;
      OccLen = 0xD748 + AtO;
      SelfUnComp[16] = OccLen & 255;
      SelfUnComp[17] = OccLen >> 8;
      OccLen = SelfUnComp[5] + (SelfUnComp[6] << 8) + AtO;
      SelfUnComp[5] = OccLen & 255;
      SelfUnComp[6] = OccLen >> 8;
   }

   do{
      OccAddr = 65535;                      // Memory references are always
      OccLen  = 0;                          // better over memory dump > 1

      if (AtI >= MaxALen)
         Occ = Temp = MaxALen;
      else
         Occ = Temp = AtI;

      if (Temp != 0)
      {
         Occ = (DWORD)memchr(BufI + AtI - Occ, BufI[AtI], Temp + 1);
         do{
            Occ -= (DWORD)BufI + AtI;
            Temp = -Occ;
            Len = 1;

            while ((Len < MaxReCLen) && (Temp > Len) && (BufI[AtI + Len] == BufI[AtI + Occ + Len]) && (AtI + Len < FLen))
               Len++;                       // We found a match! >= 2

            if (Occ == 0)                   // Check, maybe it ends in
            {                               // repeated bytes! :)
               Len = 0;
               while ((Len <= MaxReCLen) && (BufI[AtI + Occ] == BufI[AtI + Len]))
                  Len++;
            }

            if (Len > OccLen)               // We found a better match!?
            {
               OccLen  = Len;
               OccAddr = Occ;
            }
            Occ = (DWORD)memchr(BufI + AtI - Temp + 1, BufI[AtI], Temp);
         } while (Occ != NULL);
      }                                     // Check if it's better to dump or
                                            // to copy
      if ((OccLen < 2) || ((OccLen == 2) && (LenD != 0)) || ((OccLen == 2) && (OccAddr == 0)))
      {
         if (AtD == -1)
         {
            AtD = AtI;
            LenD = 1;
         }
         else if (++LenD == MaxDLen)
            SaveDump();
         AtI++;                             // Skip to the next character
      }
      else
      {
         if (OccAddr == 0)                  // Maybe we had a repeated string,
         {                                  // if so set it up for 1byte dump
            if (AtD == -1)
               AtD = AtI;
            AtI++;
            LenD++;
            OccAddr = -1;
            OccLen--;
         }

         if (LenD != 0)                     // Check if there's a dump in the
            SaveDump();                     // queue

         // Now save the memory reference (2 bytes)
         if (OccLen >= MaxCLen)
         {
            BufO[AtO++] = ((OccAddr >> 8) << MaxCBit) + MaxCLen - 2;
            BufO[AtO++] = (OccLen - MaxCLen) - 2;
            BufO[AtO++] = OccAddr & 255;
         }
         else {
            BufO[AtO++] = ((OccAddr >> 8) << MaxCBit) + OccLen - 2;
            BufO[AtO++] = OccAddr & 255;
         }
         AtI += OccLen;
      }
   } while (FLen > AtI);

   // Dump the remains
   if (LenD != 0)
      SaveDump();



   BufO[AtO++] = 0;                             // Mark the EOF
   SelfUnComp[11] = (AtO + 44) & 255;
   SelfUnComp[12] = (AtO + 44) << 8;

   // Work the .86S format
   if ((Args[1][0] == '/') && (toupper(Args[1][1]) == 'S'))
   {
      fwrite("**TI86**\x1A\x0A", 1, 11, Out);
      fwrite("Asm string created with Lite86 <C.Y.T.>  ", 1, 42, Out);
      FLen = AtO + 2;
      putw(FLen + 18 - 2, Out);

      putw(0x000C, Out);
      putw(FLen, Out);
      putc(0xC, Out);                          // String ID

      Len = 0;
      while (isalpha(*Args[ArgAt + 2]))
         ChkSum += Name[Len++] = *Args[ArgAt + 2]++;
      putc(Len, Out);
      fwrite(Name, 1, 8, Out);
      putw(FLen, Out);
      putw(FLen - 2, Out);

      ChkSum = 24 + (((FLen & 255) + (FLen >> 8)) << 1) + Len +
                     ((FLen - 2) & 255) + ((FLen - 2) >> 8);;
      for (Len = 0 ; Len < AtO ; Len++)
         ChkSum += BufO[Len];
   }

   // Work the .86P SE format
   if ((Args[1][0] == '/') && (toupper(Args[1][1]) == 'P'))
   {
      fwrite("**TI86**\x1A\x0A", 1, 11, Out);
      fwrite("Asm program created with Lite86 <C.Y.T.> ", 1, 42, Out);
      FLen = AtO + CompLen + 2 + 2;
      putw(FLen + 18 - 2, Out);

      putw(0x000C, Out);
      putw(FLen, Out);
      putc(0x12, Out);                          // Program ID

      Len = 0;
      while (isalpha(*Args[ArgAt + 2]))
         ChkSum += Name[Len++] = *Args[ArgAt + 2]++;
      putc(Len, Out);
      fwrite(Name, 1, 8, Out);
      putw(FLen, Out);
      putw(FLen - 2, Out);
      putw(0x288E, Out);

      ChkSum = 212 + (((FLen & 255) + (FLen >> 8)) << 1) + Len +
                      ((FLen - 2) & 255) + ((FLen - 2) >> 8);;
      for (Len = 0 ; Len < AtO ; Len++)
         ChkSum += BufO[Len];
      for (Len = 0 ; Len < CompLen ; Len++)
         ChkSum += SelfUnComp[Len];
   }

   // If we're supposed to start later then the start of the file
   if (ArgCount > ArgAt + 3)
   {
      fwrite(BufO, 1, atoi(Args[ArgAt + 3]), Out);
      AtO -= atoi(Args[ArgAt + 3]);
      OccLen = atoi(Args[ArgAt + 3]);
   }
   else
      OccLen = 0;

   // Work the .86P B format
   if ((Args[1][0] == '/') && ((toupper(Args[1][1]) == 'P') || (toupper(Args[1][1]) == 'X')))
      fwrite(SelfUnComp, 1, CompLen, Out);

   // Work the .ASM format
   if ((Args[1][0] == '/') && ((Args[1][1] == 't') || (Args[1][1] == 'T')))
   {
      fprintf(Out, "; Data compressed with Lite, Total Size = %d\n", AtO);
      for (FLen = OccLen ; FLen < AtO ; FLen++)
      {
         if (FLen % 12 == 0)
            fprintf(Out, "\n   .db");
         fprintf(Out, " 0%c%ch", Dec2Hex[BufO[FLen] >> 4], Dec2Hex[BufO[FLen] & 15]);
         if ((FLen %12 != 11) && (FLen != AtO - 1))
            fprintf(Out, ",");
      }
      fprintf(Out, "\n");
   }
   else
      fwrite(BufO + OccLen, 1, AtO, Out);

   if ((Args[1][0] == '/') && ((toupper(Args[1][1]) == 'P') || (toupper(Args[1][1]) == 'S')))
      putw(ChkSum, Out);

   fclose(Out);

 #ifdef gcc
   printf("o Original program size : %d\n\r", AtI);
   printf("o New program size      : %d\n\r", AtO);
   printf("o Compressing ratio     : %3.2f\n\n\r", (1 - (float)AtO / AtI) * 100);
 #else
   cprintf(" Original program size : %d\n\r", AtI);
   if (AtO >= AtI)                          // Setup a warning if we're using
      textattr(0x04);                       // more then we were originally
   cprintf(" New program size      : %d\n\r", AtO);
   cprintf(" Compressing ratio     : %3.2f\n\r", (1 - (float)AtO / AtI) * 100);
 #endif
}
