// Created by Christopher Tremblay <ti_chris@yahoo.com>
// This program will uncompress LIT86 programs on the PC

#define gcc

#include <stdio.h>
 #ifndef gcc
#include <mem.h>
 #endif

typedef unsigned char BYTE;
typedef unsigned int  WORD;

#define Exception (1 << (8 + MaxABit - 2))      // 00xxxxxx
#define MaxDBit 6                               // (  1.. 64) = 00xxxxxxb
#define MaxCBit 5                               // (  2.. 33) = ???xxxxxb
#define MaxABit 3                               // (  1..  6) = xxX?????b
// Constants calculate with the bit choices
#define MaxDLen (1 << MaxDBit)                  // where xx != 00xb
#define MaxCLen (1 << MaxCBit) + 1
#define MaxALen (1 << (8 + MaxABit)) - Exception

BYTE BufI[16384], BufO[16384];

void main(int ArgCount, char *Args[])
{
   FILE *In, *Out;
   WORD Length, Temp, AtI = 0, AtO = 0, Loop;

   // First check the arguments
   if (ArgCount < 3)
   {
      printf("Usage : %s <Source> <Destination>\n\n", Args[0]);
      return;
   }

   if ((In = fopen(Args[1], "rb")) == NULL)
   {
      printf("File not found : %s\n\n", Args[1]);
      return;
   }

   if ((Out = fopen(Args[2], "wb")) == NULL)
   {
      printf("File can't be created : %s\n\n", Args[2]);
      return;
   }

   fseek(In, 0, SEEK_END);
   Length = ftell(In);
   fseek(In, 0, SEEK_SET);
   fread(BufI, 1, Length, In);
   fclose(In);

   do{
      if (BufI[AtI] < MaxDLen)             // It's not compressed!
      {
         memcpy(BufO + AtO, BufI + AtI + 1, BufI[AtI]);
         AtO += BufI[AtI];
         AtI += BufI[AtI] + 1;
      }
      else{
         Length = (BufI[AtI] & (MaxCLen - 2)) + 2;
         Temp = ((WORD)BufI[AtI++] & (((1 << MaxABit) - 1) << MaxCBit)) << MaxABit;
         if (Length == MaxCLen)
            Length += BufI[AtI++];
         Temp = (Temp + BufI[AtI++]) | ((WORD)-(1 << (8 + MaxABit)));

         for (Loop = 0 ; Loop < Length ; Loop++)
            BufO[AtO + Loop] = BufO[AtO + Temp + Loop];
/*         if (Temp == 65535)
            memset(BufO + AtO, BufO[AtO - 1], Length);
         else
            memcpy(BufO + AtO, BufO + ((WORD)AtO + Temp), Length);*/
         AtO += Length;
      }

   } while (BufI[AtI] != 0);

   fwrite(BufO, 1, AtO, Out);
   fclose(Out);
}
